From b8be571c6914cd5d12e8670b85db44b5fadf50b7 Mon Sep 17 00:00:00 2001
From: Chris Johns <chrisj@rtems.org>
Date: Mon, 2 Aug 2021 15:09:41 +1000
Subject: [PATCH rtems-libbsd v4 15/19] sys/kern: Add VFS support

- Refactor the libio interface

- Move syscalls into an rtemsbsd location

- Provide a root directory mount point

Update #4475
---
 README.md                                     |   19 +-
 freebsd/sys/fs/deadfs/dead_vnops.c            |    2 +
 freebsd/sys/fs/pseudofs/pseudofs.c            |    4 +-
 freebsd/sys/fs/pseudofs/pseudofs_fileno.c     |    4 +-
 freebsd/sys/fs/pseudofs/pseudofs_vncache.c    |    4 +-
 freebsd/sys/fs/pseudofs/pseudofs_vnops.c      |   24 +-
 freebsd/sys/kern/kern_descrip.c               |   68 +-
 freebsd/sys/kern/kern_event.c                 |  274 +-
 freebsd/sys/kern/kern_mib.c                   |    2 -
 freebsd/sys/kern/kern_sysctl.c                |    4 -
 freebsd/sys/kern/subr_pctrie.c                |    4 +-
 freebsd/sys/kern/subr_uio.c                   |    2 +-
 freebsd/sys/kern/sys_generic.c                |  216 +-
 freebsd/sys/kern/sys_pipe.c                   |  368 +-
 freebsd/sys/kern/sys_socket.c                 |  274 +-
 freebsd/sys/kern/uipc_socket.c                |   16 -
 freebsd/sys/kern/uipc_syscalls.c              |  527 +-
 freebsd/sys/kern/uipc_usrreq.c                |   10 +-
 freebsd/sys/kern/vfs_acl.c                    |    2 +
 freebsd/sys/kern/vfs_aio.c                    |  248 +-
 freebsd/sys/kern/vfs_bio.c                    |  142 +-
 freebsd/sys/kern/vfs_cache.c                  |   14 +-
 freebsd/sys/kern/vfs_cluster.c                |    9 +-
 freebsd/sys/kern/vfs_default.c                |   36 +-
 freebsd/sys/kern/vfs_export.c                 |   18 +-
 freebsd/sys/kern/vfs_extattr.c                |    4 +
 freebsd/sys/kern/vfs_hash.c                   |    2 +
 freebsd/sys/kern/vfs_init.c                   |   14 +
 freebsd/sys/kern/vfs_lookup.c                 |   16 +-
 freebsd/sys/kern/vfs_mount.c                  |    8 +
 freebsd/sys/kern/vfs_subr.c                   |   88 +-
 freebsd/sys/kern/vfs_syscalls.c               |   68 +-
 freebsd/sys/kern/vfs_vnops.c                  |   93 +-
 freebsd/sys/net/route.c                       |   18 -
 freebsd/sys/opencrypto/cryptodev.c            |   85 +-
 freebsd/sys/sys/bio.h                         |    2 +
 freebsd/sys/sys/capsicum.h                    |    6 +-
 freebsd/sys/sys/conf.h                        |    4 -
 freebsd/sys/sys/eventvar.h                    |    2 -
 freebsd/sys/sys/file.h                        |  184 +-
 freebsd/sys/sys/filedesc.h                    |   85 +-
 freebsd/sys/sys/jail.h                        |   11 +
 freebsd/sys/sys/mount.h                       |   22 +
 freebsd/sys/sys/proc.h                        |    2 +
 freebsd/sys/sys/resourcevar.h                 |    9 +-
 freebsd/sys/sys/sysctl.h                      |    8 -
 freebsd/sys/sys/sysent.h                      |    4 +
 freebsd/sys/sys/sysproto.h                    |   94 +-
 freebsd/sys/sys/user.h                        |    4 -
 freebsd/sys/sys/vnode.h                       |   13 +-
 freebsd/sys/vm/uma_core.c                     |    8 +-
 freebsd/sys/vm/vm_extern.h                    |   12 +
 freebsd/sys/vm/vm_meter.c                     |    6 +-
 libbsd.py                                     |   49 +-
 rtemsbsd/fs/rootfs/rootfs.c                   |   94 +
 rtemsbsd/fs/rootfs/rootvfs.c                  |  656 +++
 rtemsbsd/include/machine/atomic.h             | 1805 ++-----
 rtemsbsd/include/machine/rtems-bsd-config.h   |   12 +
 .../machine/rtems-bsd-kernel-namespace.h      |  692 +++
 .../include/machine/rtems-bsd-kernel-space.h  |  154 +-
 rtemsbsd/include/machine/rtems-bsd-libio.h    |  330 ++
 rtemsbsd/include/machine/rtems-bsd-page.h     |    2 +
 rtemsbsd/include/machine/rtems-bsd-vfs.h      |   89 +
 rtemsbsd/include/rtems/bsd/bsd.h              |   14 +
 .../include/rtems/bsd/local/opt_pseudofs.h    |    0
 rtemsbsd/include/rtems/bsd/local/opt_swap.h   |    0
 .../include/rtems/bsd/local/opt_watchdog.h    |    0
 rtemsbsd/include/rtems/bsd/local/vnode_if.h   | 1951 +++++++
 .../rtems/bsd/local/vnode_if_newproto.h       |   84 +
 .../rtems/bsd/local/vnode_if_typedef.h        |  224 +
 rtemsbsd/include/rtems/bsd/rootfs.h           |   51 +
 rtemsbsd/include/sys/bio.h                    |    1 -
 rtemsbsd/include/sys/namei.h                  |    1 -
 rtemsbsd/include/sys/sysent.h                 |    1 -
 rtemsbsd/include/vm/vm_object.h               |   17 +-
 rtemsbsd/include/vm/vm_pager.h                |   20 +
 .../rtems/rtems-bsd-allocator-domain-size.c   |    1 +
 .../rtems-bsd-get-allocator-domain-size.c     |    3 +
 rtemsbsd/rtems/rtems-bsd-libio.c              |  193 +
 rtemsbsd/rtems/rtems-bsd-mountroot.c          |  124 +
 rtemsbsd/rtems/rtems-bsd-syscall-api.c        | 1506 +++++-
 rtemsbsd/rtems/rtems-kernel-capability.c      |   71 +
 rtemsbsd/rtems/rtems-kernel-dev.c             |   64 +
 rtemsbsd/rtems/rtems-kernel-dirent.c          |   52 +
 rtemsbsd/rtems/rtems-kernel-init.c            |   95 +-
 rtemsbsd/rtems/rtems-kernel-pager.c           |  171 +
 rtemsbsd/rtems/rtems-kernel-param.c           |   40 +
 rtemsbsd/rtems/rtems-kernel-vfs.c             |  941 ++++
 rtemsbsd/rtems/rtems-kernel-vmem.c            |   55 +
 rtemsbsd/sys/fs/devfs/devfs_devs.c            |  177 +-
 rtemsbsd/sys/kern/vnode_if.c                  | 4763 +++++++++++++++++
 .../include/rtems/bsd/test/default-init.h     |    7 +
 testsuite/swi01/init.c                        |    3 -
 testsuite/syscalls01/test_main.c              |   20 +-
 testsuite/thread01/test_main.c                |   12 +-
 testsuite/timeout01/init.c                    |    3 -
 wscript                                       |    4 +-
 97 files changed, 14479 insertions(+), 3236 deletions(-)
 create mode 100644 rtemsbsd/fs/rootfs/rootfs.c
 create mode 100644 rtemsbsd/fs/rootfs/rootvfs.c
 create mode 100644 rtemsbsd/include/machine/rtems-bsd-libio.h
 create mode 100644 rtemsbsd/include/machine/rtems-bsd-vfs.h
 create mode 100644 rtemsbsd/include/rtems/bsd/local/opt_pseudofs.h
 create mode 100644 rtemsbsd/include/rtems/bsd/local/opt_swap.h
 create mode 100644 rtemsbsd/include/rtems/bsd/local/opt_watchdog.h
 create mode 100644 rtemsbsd/include/rtems/bsd/local/vnode_if.h
 create mode 100644 rtemsbsd/include/rtems/bsd/local/vnode_if_newproto.h
 create mode 100644 rtemsbsd/include/rtems/bsd/local/vnode_if_typedef.h
 create mode 100644 rtemsbsd/include/rtems/bsd/rootfs.h
 delete mode 100644 rtemsbsd/include/sys/bio.h
 delete mode 100644 rtemsbsd/include/sys/namei.h
 delete mode 100644 rtemsbsd/include/sys/sysent.h
 create mode 100644 rtemsbsd/rtems/rtems-bsd-libio.c
 create mode 100644 rtemsbsd/rtems/rtems-bsd-mountroot.c
 create mode 100644 rtemsbsd/rtems/rtems-kernel-capability.c
 create mode 100644 rtemsbsd/rtems/rtems-kernel-dev.c
 create mode 100644 rtemsbsd/rtems/rtems-kernel-dirent.c
 create mode 100644 rtemsbsd/rtems/rtems-kernel-pager.c
 create mode 100644 rtemsbsd/rtems/rtems-kernel-param.c
 create mode 100644 rtemsbsd/rtems/rtems-kernel-vfs.c
 create mode 100644 rtemsbsd/rtems/rtems-kernel-vmem.c
 create mode 100644 rtemsbsd/sys/kern/vnode_if.c

diff --git a/freebsd/sys/fs/deadfs/dead_vnops.c b/freebsd/sys/fs/deadfs/dead_vnops.c
index a3153aed..3fdf252a 100644
--- a/freebsd/sys/fs/deadfs/dead_vnops.c
+++ b/freebsd/sys/fs/deadfs/dead_vnops.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
diff --git a/freebsd/sys/fs/pseudofs/pseudofs.c b/freebsd/sys/fs/pseudofs/pseudofs.c
index 73d3c7cb..519a2df5 100644
--- a/freebsd/sys/fs/pseudofs/pseudofs.c
+++ b/freebsd/sys/fs/pseudofs/pseudofs.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -31,7 +33,7 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_pseudofs.h"
+#include <rtems/bsd/local/opt_pseudofs.h>
 
 #include <sys/param.h>
 #include <sys/kernel.h>
diff --git a/freebsd/sys/fs/pseudofs/pseudofs_fileno.c b/freebsd/sys/fs/pseudofs/pseudofs_fileno.c
index 2c6b2d1f..908c89be 100644
--- a/freebsd/sys/fs/pseudofs/pseudofs_fileno.c
+++ b/freebsd/sys/fs/pseudofs/pseudofs_fileno.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -31,7 +33,7 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_pseudofs.h"
+#include <rtems/bsd/local/opt_pseudofs.h>
 
 #include <sys/param.h>
 #include <sys/kernel.h>
diff --git a/freebsd/sys/fs/pseudofs/pseudofs_vncache.c b/freebsd/sys/fs/pseudofs/pseudofs_vncache.c
index 05dd6569..c7361332 100644
--- a/freebsd/sys/fs/pseudofs/pseudofs_vncache.c
+++ b/freebsd/sys/fs/pseudofs/pseudofs_vncache.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -31,7 +33,7 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_pseudofs.h"
+#include <rtems/bsd/local/opt_pseudofs.h>
 
 #include <sys/param.h>
 #include <sys/kernel.h>
diff --git a/freebsd/sys/fs/pseudofs/pseudofs_vnops.c b/freebsd/sys/fs/pseudofs/pseudofs_vnops.c
index da35f062..3953430a 100644
--- a/freebsd/sys/fs/pseudofs/pseudofs_vnops.c
+++ b/freebsd/sys/fs/pseudofs/pseudofs_vnops.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -31,7 +33,7 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_pseudofs.h"
+#include <rtems/bsd/local/opt_pseudofs.h>
 
 #include <sys/param.h>
 #include <sys/kernel.h>
@@ -95,6 +97,7 @@ pfs_visible_proc(struct thread *td, struct pfs_node *pn, struct proc *proc)
 
 	PROC_LOCK_ASSERT(proc, MA_OWNED);
 
+#ifndef __rtems__
 	visible = ((proc->p_flag & P_WEXIT) == 0);
 	if (visible)
 		visible = (p_cansee(td, proc) == 0);
@@ -102,6 +105,7 @@ pfs_visible_proc(struct thread *td, struct pfs_node *pn, struct proc *proc)
 		visible = pn_vis(td, proc, pn);
 	if (!visible)
 		return (0);
+#endif /* __rtems__ */
 	return (1);
 }
 
@@ -118,7 +122,11 @@ pfs_visible(struct thread *td, struct pfs_node *pn, pid_t pid,
 		*p = NULL;
 	if (pid == NO_PID)
 		PFS_RETURN (1);
+#ifndef __rtems__
 	proc = allproc_locked ? pfind_locked(pid) : pfind(pid);
+#else /* __rtems__ */
+	proc = &proc0;
+#endif /* __rtems__ */
 	if (proc == NULL)
 		PFS_RETURN (0);
 	if (pfs_visible_proc(td, pn, proc)) {
@@ -177,7 +185,11 @@ pfs_close(struct vop_close_args *va)
 		PFS_RETURN (0);
 
 	if (pvd->pvd_pid != NO_PID) {
+#ifndef __rtems__
 		proc = pfind(pvd->pvd_pid);
+#else /* __rtems__ */
+		proc = &proc0;
+#endif /* __rtems__ */
 	} else {
 		proc = NULL;
 	}
@@ -241,13 +253,17 @@ pfs_getattr(struct vop_getattr_args *va)
 		break;
 	}
 
+#ifndef __rtems__
 	if (proc != NULL) {
 		vap->va_uid = proc->p_ucred->cr_ruid;
 		vap->va_gid = proc->p_ucred->cr_rgid;
 	} else {
+#endif /* __rtems__ */
 		vap->va_uid = 0;
 		vap->va_gid = 0;
+#ifndef __rtems__
 	}
+#endif /* __rtems__ */
 
 	if (pn->pn_attr != NULL)
 		error = pn_attr(curthread, proc, pn, vap);
@@ -713,10 +729,14 @@ pfs_iterate(struct thread *td, struct proc *proc, struct pfs_node *pd,
 	}
 	if (*pn != NULL && (*pn)->pn_type == pfstype_procdir) {
 		/* next process */
+#ifndef __rtems__
 		if (*p == NULL)
 			*p = LIST_FIRST(&allproc);
 		else
 			*p = LIST_NEXT(*p, p_list);
+#else /* __rtems__ */
+		*p = &proc0;
+#endif /* __rtems__ */
 		/* out of processes: next node */
 		if (*p == NULL)
 			*pn = (*pn)->pn_next;
@@ -895,6 +915,7 @@ pfs_readlink(struct vop_readlink_args *va)
 	if (pn->pn_fill == NULL)
 		PFS_RETURN (EIO);
 
+#ifndef __rtems__
 	if (pvd->pvd_pid != NO_PID) {
 		if ((proc = pfind(pvd->pvd_pid)) == NULL)
 			PFS_RETURN (EIO);
@@ -905,6 +926,7 @@ pfs_readlink(struct vop_readlink_args *va)
 		_PHOLD(proc);
 		PROC_UNLOCK(proc);
 	}
+#endif /* __rtems__ */
 	vhold(vn);
 	locked = VOP_ISLOCKED(vn);
 	VOP_UNLOCK(vn, 0);
diff --git a/freebsd/sys/kern/kern_descrip.c b/freebsd/sys/kern/kern_descrip.c
index 423968b2..ddc50633 100644
--- a/freebsd/sys/kern/kern_descrip.c
+++ b/freebsd/sys/kern/kern_descrip.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -39,9 +41,9 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_capsicum.h"
-#include "opt_ddb.h"
-#include "opt_ktrace.h"
+#include <rtems/bsd/local/opt_capsicum.h>
+#include <rtems/bsd/local/opt_ddb.h>
+#include <rtems/bsd/local/opt_ktrace.h>
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -74,7 +76,7 @@ __FBSDID("$FreeBSD$");
 #include <sys/syscallsubr.h>
 #include <sys/sysctl.h>
 #include <sys/sysproto.h>
-#include <sys/unistd.h>
+#include <rtems/bsd/sys/unistd.h>
 #include <sys/user.h>
 #include <sys/vnode.h>
 #ifdef KTRACE
@@ -360,6 +362,7 @@ sys_getdtablesize(struct thread *td, struct getdtablesize_args *uap)
 	return (0);
 }
 
+#ifndef __rtems__
 /*
  * Duplicate a file descriptor to a particular value.
  *
@@ -480,6 +483,7 @@ kern_fcntl_freebsd(struct thread *td, int fd, int cmd, long arg)
 	}
 	return (error);
 }
+#endif /* __rtems__ */
 
 int
 kern_fcntl(struct thread *td, int fd, int cmd, intptr_t arg)
@@ -502,6 +506,7 @@ kern_fcntl(struct thread *td, int fd, int cmd, intptr_t arg)
 	AUDIT_ARG_FD(cmd);
 	AUDIT_ARG_CMD(cmd);
 	switch (cmd) {
+#ifndef __rtems__
 	case F_DUPFD:
 		tmp = arg;
 		error = kern_dup(td, FDDUP_FCNTL, 0, fd, tmp);
@@ -521,6 +526,7 @@ kern_fcntl(struct thread *td, int fd, int cmd, intptr_t arg)
 		tmp = arg;
 		error = kern_dup(td, FDDUP_FIXED, FDDUP_FLAG_CLOEXEC, fd, tmp);
 		break;
+#endif /* __rtems__ */
 
 	case F_GETFD:
 		error = EBADF;
@@ -581,6 +587,7 @@ kern_fcntl(struct thread *td, int fd, int cmd, intptr_t arg)
 		fdrop(fp, td);
 		break;
 
+#ifndef __rtems__
 	case F_GETOWN:
 		error = fget_fcntl(td, fd, &cap_fcntl_rights, F_GETOWN, &fp);
 		if (error != 0)
@@ -797,6 +804,7 @@ kern_fcntl(struct thread *td, int fd, int cmd, intptr_t arg)
 		VOP_UNLOCK(vp, 0);
 		fdrop(fp, td);
 		break;
+#endif /* __rtems__ */
 
 	default:
 		error = EINVAL;
@@ -812,6 +820,7 @@ getmaxfd(struct thread *td)
 	return (min((int)lim_cur(td, RLIMIT_NOFILE), maxfilesperproc));
 }
 
+#ifndef __rtems__
 /*
  * Common code for dup, dup2, fcntl(F_DUPFD) and fcntl(F_DUP2FD).
  */
@@ -1173,6 +1182,7 @@ fgetown(struct sigio **sigiop)
 	SIGIO_UNLOCK();
 	return (pgid);
 }
+#endif /* __rtems__ */
 
 /*
  * Function drops the filedesc lock on return.
@@ -1263,6 +1273,7 @@ kern_close(struct thread *td, int fd)
 	return (closefp(fdp, fd, fp, td, 1));
 }
 
+#ifndef __rtems__
 /*
  * Close open file descriptors.
  */
@@ -1298,6 +1309,7 @@ sys_closefrom(struct thread *td, struct closefrom_args *uap)
 	FILEDESC_SUNLOCK(fdp);
 	return (0);
 }
+#endif /* __rtems__ */
 
 #if defined(COMPAT_43)
 /*
@@ -1424,6 +1436,7 @@ freebsd11_nfstat(struct thread *td, struct freebsd11_nfstat_args *uap)
 }
 #endif /* COMPAT_FREEBSD11 */
 
+#ifndef __rtems__
 /*
  * Return pathconf information about a file descriptor.
  */
@@ -1480,6 +1493,7 @@ out:
 	fdrop(fp, td);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Initialize filecaps structure.
@@ -1614,6 +1628,7 @@ static void
 filecaps_validate(const struct filecaps *fcaps, const char *func)
 {
 
+#ifndef __rtems__
 	KASSERT(cap_rights_is_valid(&fcaps->fc_rights),
 	    ("%s: invalid rights", func));
 	KASSERT((fcaps->fc_fcntls & ~CAP_FCNTL_ALL) == 0,
@@ -1627,6 +1642,7 @@ filecaps_validate(const struct filecaps *fcaps, const char *func)
 	KASSERT(fcaps->fc_nioctls == 0 ||
 	    cap_rights_is_set(&fcaps->fc_rights, CAP_IOCTL),
 	    ("%s: ioctls without CAP_IOCTL", func));
+#endif /* __rtems__ */
 }
 
 static void
@@ -1875,10 +1891,12 @@ falloc_noinstall(struct thread *td, struct file **resultfp)
 	    priv_check(td, PRIV_MAXFILES) != 0) ||
 	    openfiles_new >= maxfiles) {
 		atomic_subtract_int(&openfiles, 1);
+#ifndef __rtems__
 		if (ppsratecheck(&lastfail, &curfail, 1)) {
 			printf("kern.maxfiles limit exceeded by uid %i, (%s) "
 			    "please see tuning(7).\n", td->td_ucred->cr_ruid, td->td_proc->p_comm);
 		}
+#endif /* __rtems__ */
 		return (ENFILE);
 	}
 	fp = uma_zalloc(file_zone, M_WAITOK);
@@ -2032,6 +2050,7 @@ fdshare(struct filedesc *fdp)
 	return (fdp);
 }
 
+#ifndef __rtems__
 /*
  * Unshare a filedesc structure, if necessary by making a copy
  */
@@ -2385,6 +2404,7 @@ fdsetugidsafety(struct thread *td)
 		}
 	}
 }
+#endif /* __rtems__ */
 
 /*
  * If a specific file object occupies a specific file descriptor, close the
@@ -2407,6 +2427,7 @@ fdclose(struct thread *td, struct file *fp, int idx)
 		FILEDESC_XUNLOCK(fdp);
 }
 
+#ifndef __rtems__
 /*
  * Close any files on exec?
  */
@@ -2432,6 +2453,7 @@ fdcloseexec(struct thread *td)
 		}
 	}
 }
+#endif /* __rtems__ */
 
 /*
  * It is unsafe for set[ug]id processes to be started with file
@@ -2500,6 +2522,7 @@ closef(struct file *fp, struct thread *td)
 	 */
 	if (fp->f_type == DTYPE_VNODE && td != NULL) {
 		vp = fp->f_vnode;
+#ifndef __rtems__
 		if ((td->td_proc->p_leader->p_flag & P_ADVLOCK) != 0) {
 			lf.l_whence = SEEK_SET;
 			lf.l_start = 0;
@@ -2508,6 +2531,7 @@ closef(struct file *fp, struct thread *td)
 			(void) VOP_ADVLOCK(vp, (caddr_t)td->td_proc->p_leader,
 			    F_UNLCK, &lf, F_POSIX);
 		}
+#endif /* __rtems__ */
 		fdtol = td->td_proc->p_fdtol;
 		if (fdtol != NULL) {
 			/*
@@ -2519,8 +2543,10 @@ closef(struct file *fp, struct thread *td)
 			for (fdtol = fdtol->fdl_next;
 			    fdtol != td->td_proc->p_fdtol;
 			    fdtol = fdtol->fdl_next) {
+#ifndef __rtems__
 				if ((fdtol->fdl_leader->p_flag &
 				    P_ADVLOCK) == 0)
+#endif /* __rtems__ */
 					continue;
 				fdtol->fdl_holdcount++;
 				FILEDESC_XUNLOCK(fdp);
@@ -2720,6 +2746,18 @@ fget_unlocked(struct filedesc *fdp, int fd, cap_rights_t *needrightsp,
 		*seqp = seq;
 #endif
 	}
+#ifdef __rtems__
+	if (fp->f_io != NULL) {
+		rtems_libio_iop_hold(fp->f_io);
+		if (RTEMS_BSD_DESCRIP_TRACE)
+			printf("bsd:  fb: fget_unlocked: iop=%p %d (%d)  fp=%p (%d) by %p\n",
+			       fp->f_io, fp->f_io->data0, fp->f_io->flags >> 12,
+			       fp, fp->f_count, __builtin_return_address(0));
+	} else if (RTEMS_BSD_DESCRIP_TRACE) {
+		printf("bsd:  fb: fget_unlocked: iop=NULL -1 (0) fp=%p (%d) by %p\n",
+		       fp, fp->f_count, __builtin_return_address(0));
+	}
+#endif /* __rtems__ */
 	return (0);
 }
 
@@ -2764,11 +2802,13 @@ _fget(struct thread *td, int fd, struct file **fpp, int flags,
 		if ((fp->f_flag & flags) == 0)
 			error = EBADF;
 		break;
+#ifndef __rtems__
 	case FEXEC:
 	    	if ((fp->f_flag & (FREAD | FEXEC)) == 0 ||
 		    ((fp->f_flag & FWRITE) != 0))
 			error = EBADF;
 		break;
+#endif /* __rtems__ */
 	case 0:
 		break;
 	default:
@@ -2791,6 +2831,7 @@ fget(struct thread *td, int fd, cap_rights_t *rightsp, struct file **fpp)
 	return (_fget(td, fd, fpp, 0, rightsp, NULL));
 }
 
+#ifndef __rtems__
 int
 fget_mmap(struct thread *td, int fd, cap_rights_t *rightsp, u_char *maxprotp,
     struct file **fpp)
@@ -2825,6 +2866,7 @@ fget_mmap(struct thread *td, int fd, cap_rights_t *rightsp, u_char *maxprotp,
 #endif
 	return (error);
 }
+#endif /* __rtems__ */
 
 int
 fget_read(struct thread *td, int fd, cap_rights_t *rightsp, struct file **fpp)
@@ -2944,12 +2986,14 @@ fgetvp_read(struct thread *td, int fd, cap_rights_t *rightsp, struct vnode **vpp
 	return (_fgetvp(td, fd, FREAD, rightsp, vpp));
 }
 
+#ifndef __rtems__
 int
 fgetvp_exec(struct thread *td, int fd, cap_rights_t *rightsp, struct vnode **vpp)
 {
 
 	return (_fgetvp(td, fd, FEXEC, rightsp, vpp));
 }
+#endif /* __rtems__ */
 
 #ifdef notyet
 int
@@ -2977,12 +3021,15 @@ _fdrop(struct file *fp, struct thread *td)
 	error = fo_close(fp, td);
 	atomic_subtract_int(&openfiles, 1);
 	crfree(fp->f_cred);
+#ifndef __rtems__
 	free(fp->f_advice, M_FADVISE);
+#endif /* __rtems__ */
 	uma_zfree(file_zone, fp);
 
 	return (error);
 }
 
+#ifndef __rtems__
 /*
  * Apply an advisory lock on a file descriptor.
  *
@@ -3201,6 +3248,7 @@ pwd_chroot(struct thread *td, struct vnode *vp)
 	vrele(oldvp);
 	return (0);
 }
+#endif /* __rtems__ */
 
 void
 pwd_chdir(struct thread *td, struct vnode *vp)
@@ -3225,6 +3273,7 @@ pwd_chdir(struct thread *td, struct vnode *vp)
 void
 mountcheckdirs(struct vnode *olddp, struct vnode *newdp)
 {
+#ifndef __rtems__
 	struct filedesc *fdp;
 	struct prison *pr;
 	struct proc *p;
@@ -3285,6 +3334,7 @@ mountcheckdirs(struct vnode *olddp, struct vnode *newdp)
 	sx_sunlock(&allprison_lock);
 	while (nrele--)
 		vrele(olddp);
+#endif /* __rtems__ */
 }
 
 struct filedesc_to_leader *
@@ -3312,6 +3362,7 @@ filedesc_to_leader_alloc(struct filedesc_to_leader *old, struct filedesc *fdp, s
 	return (fdtol);
 }
 
+#ifndef __rtems__
 static int
 sysctl_kern_proc_nfds(SYSCTL_HANDLER_ARGS)
 {
@@ -3810,6 +3861,7 @@ static SYSCTL_NODE(_kern_proc, KERN_PROC_OFILEDESC, ofiledesc,
     CTLFLAG_RD|CTLFLAG_MPSAFE, sysctl_kern_proc_ofiledesc,
     "Process ofiledesc entries");
 #endif	/* COMPAT_FREEBSD7 */
+#endif /* __rtems__ */
 
 int
 vntype_to_kinfo(int vtype)
@@ -3840,6 +3892,7 @@ vntype_to_kinfo(int vtype)
 	return (KF_VTYPE_UNKNOWN);
 }
 
+#ifndef __rtems__
 static SYSCTL_NODE(_kern_proc, KERN_PROC_FILEDESC, filedesc,
     CTLFLAG_RD|CTLFLAG_MPSAFE, sysctl_kern_proc_filedesc,
     "Process filedesc entries");
@@ -3911,6 +3964,7 @@ sysctl_kern_proc_cwd(SYSCTL_HANDLER_ARGS)
 
 static SYSCTL_NODE(_kern_proc, KERN_PROC_CWD, cwd, CTLFLAG_RD|CTLFLAG_MPSAFE,
     sysctl_kern_proc_cwd, "Process current working directory");
+#endif /* __rtems__ */
 
 #ifdef DDB
 /*
@@ -4059,7 +4113,11 @@ filelistinit(void *dummy)
 	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, 0);
 	mtx_init(&sigio_lock, "sigio lock", NULL, MTX_DEF);
 }
+#ifndef __rtems__
 SYSINIT(select, SI_SUB_LOCK, SI_ORDER_FIRST, filelistinit, NULL);
+#else /* __rtems__ */
+SYSINIT(select_sub_lock, SI_SUB_LOCK, SI_ORDER_FIRST, filelistinit, NULL);
+#endif /* __rtems__ */
 
 /*-------------------------------------------------------------------*/
 
@@ -4228,6 +4286,7 @@ invfo_sendfile(struct file *fp, int sockfd, struct uio *hdr_uio,
 	return (EINVAL);
 }
 
+#ifndef __rtems__
 /*-------------------------------------------------------------------*/
 
 /*
@@ -4281,3 +4340,4 @@ fildesc_drvinit(void *unused)
 }
 
 SYSINIT(fildescdev, SI_SUB_DRIVERS, SI_ORDER_MIDDLE, fildesc_drvinit, NULL);
+#endif /* __rtems__ */
